diff --git a/examples/widgets/mainwindows/mdi/mdi.pro b/examples/widgets/mainwindows/mdi/mdi.pro
index 2e3c232..1275170 100644
--- a/examples/widgets/mainwindows/mdi/mdi.pro
+++ b/examples/widgets/mainwindows/mdi/mdi.pro
@@ -4,7 +4,7 @@ HEADERS       = mainwindow.h \
                 mdichild.h
 SOURCES       = main.cpp \
                 mainwindow.cpp \
-                mdichild.cpp
+                mdichild.cpp foo.cpp
 RESOURCES     = mdi.qrc
 
 # install
diff --git a/src/widgets/styles/qwindowsvistastyle.cpp b/src/widgets/styles/qwindowsvistastyle.cpp
index 3136118..5914881 100644
--- a/src/widgets/styles/qwindowsvistastyle.cpp
+++ b/src/widgets/styles/qwindowsvistastyle.cpp
@@ -300,6 +300,7 @@ void QWindowsVistaStyle::drawPrimitive(PrimitiveElement element, const QStyleOpt
 
                     QWindowsVistaAnimation *anim = qobject_cast<QWindowsVistaAnimation *>(d->animation(styleObject));
                     QWindowsVistaTransition *t = new QWindowsVistaTransition(styleObject);
+                    qDebug() << __FUNCTION__ << "----------- creating transition";
 
                     // We create separate images for the initial and final transition states and store them in the
                     // Transition object.
@@ -314,10 +315,15 @@ void QWindowsVistaStyle::drawPrimitive(PrimitiveElement element, const QStyleOpt
                     // If we have a running animation on the widget already, we will use that to paint the initial
                     // state of the new transition, this ensures a smooth transition from a current animation such as a
                     // pulsating default button into the intended target state.
-                    if (!anim)
+                    if (!anim) {
+                        qDebug() << ">Drawing start";
                         proxy()->drawPrimitive(element, styleOption, &startPainter, widget);
-                    else
+                        qDebug() << "<Drawing start";
+                    } else {
+                        qDebug() << ">Drawing anim start";
                         anim->paint(&startPainter, styleOption);
+                        qDebug() << "<Drawing anim start";
+                    }
 
                     t->setStartImage(startImage);
 
@@ -325,7 +331,9 @@ void QWindowsVistaStyle::drawPrimitive(PrimitiveElement element, const QStyleOpt
                     // if the style was not animated.
                     styleOption->styleObject = 0;
                     styleOption->state = option->state;
+                    qDebug() << ">Drawing end";
                     proxy()->drawPrimitive(element, styleOption, &endPainter, widget);
+                    qDebug() << "<Drawing end";
 
 
                     t->setEndImage(endImage);
@@ -380,6 +388,7 @@ void QWindowsVistaStyle::drawPrimitive(PrimitiveElement element, const QStyleOpt
                     d->startAnimation(t);
                 }
                 styleObject->setProperty("_q_no_animation", false);
+                qDebug() << __FUNCTION__ << "----------- created transition";
             }
 
         } // End of animation part
@@ -522,6 +531,7 @@ void QWindowsVistaStyle::drawPrimitive(PrimitiveElement element, const QStyleOpt
                 bg = panel->palette.brush(QPalette::Base);
                 usePalette = true;
             }
+            qDebug() << __FUNCTION__ << "PE_PanelLineEdit usePalette=" <<usePalette;
             if (usePalette) {
                 painter->fillRect(panel->rect, bg);
             } else {
@@ -571,9 +581,11 @@ void QWindowsVistaStyle::drawPrimitive(PrimitiveElement element, const QStyleOpt
 
     case PE_FrameLineEdit:
         if (QWindowsVistaAnimation *anim = qobject_cast<QWindowsVistaAnimation *>(d->animation(styleObject(option)))) {
+            qDebug() << __FUNCTION__ << "PE_FrameLineEdit anim" <<anim;
             anim->paint(painter, option);
         } else {
             QPainter *p = painter;
+            qDebug() << __FUNCTION__ << "PE_FrameLineEdit non-anim";
             if (QWindowsXPStylePrivate::isItemViewDelegateLineEdit(widget)) {
                 // we try to check if this lineedit is a delegate on a QAbstractItemView-derived class.
                 QPen oldPen = p->pen();
@@ -586,6 +598,7 @@ void QWindowsVistaStyle::drawPrimitive(PrimitiveElement element, const QStyleOpt
                 p->setPen(oldPen);
                 return;
             } else {
+                qDebug() << __FUNCTION__ << "PE_FrameLineEdit theme";
                 int stateId = ETS_NORMAL;
                 if (!(state & State_Enabled))
                     stateId = ETS_DISABLED;
diff --git a/src/widgets/styles/qwindowsxpstyle.cpp b/src/widgets/styles/qwindowsxpstyle.cpp
index 7529bca..b1fc74d 100644
--- a/src/widgets/styles/qwindowsxpstyle.cpp
+++ b/src/widgets/styles/qwindowsxpstyle.cpp
@@ -1627,7 +1627,7 @@ case PE_Frame:
             }
 
             stateId = isEnabled ? ETS_NORMAL : ETS_DISABLED;
-
+qDebug() << __FUNCTION__ << "usePalette=" <<usePalette;
             if (usePalette) {
                 p->fillRect(panel->rect, bg);
             } else {