diff --git a/src/gui/image/qpixmapcache.cpp b/src/gui/image/qpixmapcache.cpp
index d29ddcf..8bf05b3 100644
--- a/src/gui/image/qpixmapcache.cpp
+++ b/src/gui/image/qpixmapcache.cpp
@@ -80,6 +80,17 @@ QT_BEGIN_NAMESPACE
     \sa QCache, QPixmap
 */
 
+QDebug operator<<(QDebug d , const QPixmapCache::Key &k)
+{
+    d << "Key(";
+    if (k.d)
+        d << k.d->isValid << k.d->key;
+    else
+        d << '0';
+    d << ')';
+    return d;
+}
+
 static int cache_limit = 10240; // 10 MB cache limit
 
 /*!
@@ -499,6 +510,15 @@ bool QPixmapCache::find(const QString &key, QPixmap& pixmap)
 bool QPixmapCache::find(const QString &key, QPixmap* pixmap)
 {
     QPixmap *ptr = pm_cache()->object(key);
+   {
+        QDebug d = qDebug();
+        d << __FUNCTION__ << key;
+        if (ptr)
+            d << *ptr;
+        else
+            d << "MISS!";
+
+    }
     if (ptr && pixmap)
         *pixmap = *ptr;
     return ptr != 0;
@@ -546,6 +566,8 @@ bool QPixmapCache::find(const Key &key, QPixmap* pixmap)
 
 bool QPixmapCache::insert(const QString &key, const QPixmap &pixmap)
 {
+    qDebug() << __FUNCTION__ << key << pixmap
+             << "cacheSize=" << pm_cache()->size();
     return pm_cache()->insert(key, pixmap, pixmap.width() * pixmap.height() * pixmap.depth() / 8);
 }
 
@@ -566,6 +588,8 @@ bool QPixmapCache::insert(const QString &key, const QPixmap &pixmap)
 */
 QPixmapCache::Key QPixmapCache::insert(const QPixmap &pixmap)
 {
+    qDebug() << __FUNCTION__ << pixmap
+             << "cacheSize=" << pm_cache()->size();
     return pm_cache()->insert(pixmap, pixmap.width() * pixmap.height() * pixmap.depth() / 8);
 }
 
@@ -580,6 +604,8 @@ QPixmapCache::Key QPixmapCache::insert(const QPixmap &pixmap)
 */
 bool QPixmapCache::replace(const Key &key, const QPixmap &pixmap)
 {
+    qDebug() << __FUNCTION__ << key << pixmap
+                << "cacheSize=" << pm_cache()->size();
     //The key is not valid anymore, a flush happened before probably
     if (!key.d || !key.d->isValid)
         return false;
@@ -609,6 +635,7 @@ int QPixmapCache::cacheLimit()
 
 void QPixmapCache::setCacheLimit(int n)
 {
+    qDebug() << __FUNCTION__ << n;
     cache_limit = n;
     pm_cache()->setMaxCost(1024 * cache_limit);
 }
@@ -618,6 +645,8 @@ void QPixmapCache::setCacheLimit(int n)
 */
 void QPixmapCache::remove(const QString &key)
 {
+    qDebug() << __FUNCTION__ << key
+                << "cacheSize=" << pm_cache()->size();
     pm_cache()->remove(key);
 }
 
@@ -629,6 +658,7 @@ void QPixmapCache::remove(const QString &key)
 */
 void QPixmapCache::remove(const Key &key)
 {
+    qDebug() << __FUNCTION__ << key;
     //The key is not valid anymore, a flush happened before probably
     if (!key.d || !key.d->isValid)
         return;
diff --git a/src/gui/image/qpixmapcache.h b/src/gui/image/qpixmapcache.h
index 37a0588..0d13a43 100644
--- a/src/gui/image/qpixmapcache.h
+++ b/src/gui/image/qpixmapcache.h
@@ -60,7 +60,6 @@ public:
 
         void swap(Key &other) Q_DECL_NOTHROW { qSwap(d, other.d); }
 
-    private:
         KeyData *d;
         friend class QPMCache;
         friend class QPixmapCache;
diff --git a/src/widgets/styles/qstylehelper.cpp b/src/widgets/styles/qstylehelper.cpp
index 6602b58..bbe50fb 100644
--- a/src/widgets/styles/qstylehelper.cpp
+++ b/src/widgets/styles/qstylehelper.cpp
@@ -43,12 +43,31 @@
 
 #include "qstylehelper_p.h"
 #include <qstringbuilder.h>
+#include <qdebug.h>
 
 QT_BEGIN_NAMESPACE
 
 Q_GUI_EXPORT int qt_defaultDpiX();
 
 namespace QStyleHelper {
+QDebug operator<<(QDebug d, const QStyleOption *option)
+{
+    QDebugStateSaver s(d);
+    d.nospace();
+    d << "QStyleOption(";
+    if (option) {
+        const QStyleOptionComplex *complexOption = qstyleoption_cast<const QStyleOptionComplex *>(option);
+        d << "state=" << option->state << ", direction="
+          << option->direction;
+        if (complexOption)
+            d << ", activeSubControls" << complexOption->activeSubControls;
+        d  << ", palette.cacheKey=" << option->palette.cacheKey();
+    } else {
+        d << '0';
+    }
+    d << ')';
+    return d;
+}
 
 QString uniqueName(const QString &key, const QStyleOption *option, const QSize &size)
 {
@@ -67,6 +86,7 @@ QString uniqueName(const QString &key, const QStyleOption *option, const QSize &
                   % QLatin1Char(spinBox->frame ? '1' : '0'); ;
     }
 #endif // QT_NO_SPINBOX
+    qDebug() << __FUNCTION__ << key << option << size << "rets" << tmp;
     return tmp;
 }
 